Package: sigora
Type: Package
Title: Signature Overrepresentation Analysis
Version: 3.2.0
Date: 2026-03-21
Authors@R: c(
        person("Amir", "Foroushani",
        email = c("sigora.dev@gmail.com"),
        role = c("aut"),
        comment = c(ORCID = "0000-0003-2748-3009")),
        person("Fiona", "Brinkman",
        email = c("sigora.dev@gmail.com"),
        role = c("aut")),
        person("David", "Lynn",
        email = c("sigora.dev@gmail.com"),
        role = c("aut")),
        person("Witold", "Wolski",
        email = c("witold.wolski@fgcz.uzh.ch"),
        role = c("cre"),
        comment = c(ORCID = "0000-0002-6468-120X"))
        )
Depends: R (>= 3.0.0)
URL: https://github.com/wolski/sigora
BugReports: https://github.com/wolski/sigora/issues
Imports: stats, slam
Suggests: knitr, rmarkdown
Description: 
     Pathway Analysis is statistically linking observations on 
     the molecular level to biological processes or pathways on 
     the systems(i.e., organism, organ, tissue, cell) level.  
     Traditionally, pathway analysis methods regard pathways 
     as collections of single genes and treat all genes in a pathway
     as equally informative. However, this can lead to identifying
     spurious pathways as statistically significant since components
     are often shared amongst pathways. SIGORA seeks to avoid this
     pitfall by focusing on genes or gene pairs that are (as a combination)
     specific to a single pathway.
     In relying on such pathway gene-pair signatures (Pathway-GPS),
     SIGORA inherently uses the status of other genes in the
     experimental context to identify the most relevant pathways.
     The current version allows for pathway analysis of human
     and mouse datasets. In addition, it contains pre-computed
     Pathway-GPS data for pathways in the KEGG and  Reactome
     pathway repositories and mechanisms for extracting GPS
     for user-supplied repositories.
Encoding: UTF-8
License: GPL-3
NeedsCompilation: no
biocViews: GeneSetEnrichment, GO, Software, Pathways, KEGG
RoxygenNote: 7.3.3
VignetteBuilder: knitr
Packaged: 2026-03-21 09:48:36 UTC; wolski
Author: Amir Foroushani [aut] (ORCID: <https://orcid.org/0000-0003-2748-3009>),
  Fiona Brinkman [aut],
  David Lynn [aut],
  Witold Wolski [cre] (ORCID: <https://orcid.org/0000-0002-6468-120X>)
Maintainer: Witold Wolski <witold.wolski@fgcz.uzh.ch>
Repository: CRAN
Date/Publication: 2026-03-21 10:30:02 UTC
Built: R 4.6.0; ; 2026-04-25 22:20:30 UTC; unix

# About the project

This repository is a fork of cran/sigora repository 
https://github.com/cran/sigora

Package ‘sigora’ was removed from the CRAN repository.
It was archived on 2021-04-10 as check problems were not corrected in time.


The code changes made in the project aim at removing all ERROR's and WARNING's from the `R CMD check` and `BiocCheck`.

# Pathway-GPS and SIGORA: identifying relevant pathways based on the over-representation of their gene-pair signatures


Pathway Analysis is statistically linking observations on 
the molecular level to biological processes or pathways on 
the systems(i.e., organism, organ, tissue, cell) level.  
Traditionally, pathway analysis methods regard pathways 
as collections of single genes and treat all genes in a pathway
as equally informative. However, this can lead to identifying
spurious pathways as statistically significant since components
are often shared amongst pathways. SIGORA seeks to avoid this
pitfall by focusing on genes or gene pairs that are (as a combination)
specific to a single pathway.
In relying on such pathway gene-pair signatures (Pathway-GPS),
SIGORA inherently uses the status of other genes in the
experimental context to identify the most relevant pathways.
The current version allows for pathway analysis of human
and mouse datasets. In addition, it contains pre-computed
Pathway-GPS data for pathways in the KEGG and  Reactome
pathway repositories and mechanisms for extracting GPS
for user-supplied repositories.

Author: Amir B.K. Foroushani


# HowTO install the Sigora package

```{r}
remoteds::install_githug("wolski/sigora")
```

For more information about the Sigora package, see:
<a href="https://wolski.github.io/sigora/" target="_blank">wolski.github.io/sigora</a>

# CRAN submission

1. Ensure a clean check with no errors, warnings, or notes:

```bash
make check
```

2. Run CRAN-specific incoming checks:

```r
devtools::check(remote = TRUE, manual = TRUE)
```

3. Submit to CRAN via `devtools::release()` (interactive, recommended):

```r
devtools::release()
```

Or manually:

```bash
# Build the tarball
R CMD build .

# Upload sigora_3.1.1.tar.gz at:
# https://cran.r-project.org/submit.html
```

The manual form asks for the tarball, your name, email (must match the maintainer in DESCRIPTION), and an optional comment to CRAN reviewers. You will receive a confirmation email — the submission is not complete until you click the link in that email.

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)

## -----------------------------------------------------------------------------
library("sigora")

## -----------------------------------------------------------------------------
data(kegH)
set.seed(seed = 12345)
a1 <- genesFromRandomPathways(kegH, 3, 50)
## originally selected pathways:
a1[["selectedPathways"]] ## what are the genes
a1[["genes"]]
## Traditional ora identifies many significant pathways!

head(ora(a1[["genes"]], kegH))
## Now let us try sigora with the same input:

sigoraRes <-
  sigora(GPSrepo = kegH,
         queryList = a1[["genes"]],
         level = 4)
## Again, the three originally selected pathways were:
a1[["selectedPathways"]]


## -----------------------------------------------------------------------------
data(nciTable)
## what does the input look like?
head(nciTable)
## create a SigObject. use saveFile for future reuse.
data(idmap)
nciH <- makeGPS(
  pathwayTable = nciTable, saveFile = NULL
)
ils <- grep("^IL", idmap[, "Symbol"], value = TRUE)
ilnci <- sigora(
  queryList = ils, GPSrepo = nciH, level = 3
)


## -----------------------------------------------------------------------------
sigRes <-
  sigora(kegH,
         queryList = a1$genes,
         level = 2,
         saveFile = NULL)


## -----------------------------------------------------------------------------
data("kegH")
data("idmap")
barplot(
  table(kegH$L1$degs),
  col = "red",
  main = "functions per gene in KEGG human pathways",
  ylab = "frequency",
  xlab = "number of functions per gene"
)
## creating your own GPS repository
nciH <- makeGPS(pathwayTable = load_data("nciTable"))
ils <- grep(
  "^IL", idmap[, "Symbol"], value = TRUE
)
## signature overrepresentation analysis:
sigRes.ilnci <- sigora(
  queryList = ils, GPSrepo = nciH, level = 3
)


## -----------------------------------------------------------------------------
sessionInfo()

#' Identifier mappings for protein coding genes.
#'
#' A mapping table for ENSEMBL, ENTREZ and gene names(HGNC/MGI symbols) of
#' Human and mouse protein coding gene.
#'
#'
#' @name idmap
#' @source www.ensembl.org/biomart/martview
#' @docType data
#' @keywords datasets
#' @examples
#'
#' data(idmap)
#' head(idmap)
#'
NULL

#' Pathway GPS data, extracted from KEGG repository (Human).
#'
#' KEGG human pathway GPS data, extracted by \code{makeGPS}, default settings.
#' This data can be used by \code{sigora} to preform signature
#' overrepresenation.
#'
#'
#' @name kegH
#' @docType data
#' @seealso \code{\link{makeGPS}}, \code{\link{sigora}} , \code{\link{reaH}}
#' @references Kanehisa, M., Goto, S., Sato, Y., Furumichi, M., & Tanabe, M.
#' 2012. \dQuote{KEGG for integration and interpretation of large-scale
#' molecular data sets.} \emph{Nucleic Acids Research} \bold{40}(D1).
#' @source <http://www.genome.jp/kegg/pathway.html>
#' @keywords datasets
#' @examples
#'
#' data(kegH)
#' str(kegH)
#'
NULL


#' Pathway GPS data, extracted from KEGG repository (Mouse).
#'
#' KEGG mouse pathway GPS data, extracted by \code{makeGPS}, default settings.
#' This data can be used by \code{sigora} to preform signature
#' overrepresenation.
#'
#'
#' @name kegM
#' @docType data
#' @references Kanehisa, M., Goto, S., Sato, Y., Furumichi, M., & Tanabe, M.
#' 2012. \dQuote{KEGG for integration and interpretation of large-scale
#' molecular data sets.} \emph{Nucleic Acids Research} \bold{40}(D1).
#' @source <http://www.genome.jp/kegg/pathway.html>
#' @keywords datasets
#' @examples
#'
#' data(kegM)
#' ## maybe str(kegM) ; plot(kegM) ...
#'
NULL


#' NCI human gene-pathway associations.
#'
#' PID-NCI human pathway repository, as a data frame with three columns
#' corresponding to : pathwayId , pathwayName, gene. This is an example of the
#' expected format for the input data to \code{makeGPS}.
#'
#' This dataset is provided to illustrate how to create your own GPS
#' repositories.\code{nciTable} is a dataframe with threecolumns corresponding
#' to pathwayId, pathwayName and gene.  Each row describes the association
#' between an individual gene and a PID-NCI pathway.  As you see in the
#' \code{examples}, section, one can convert this dataframe to a \code{GPS
#' repository} using \code{makeGPS}, and save the results for future reuse.
#' Using the thus created \code{GPS repository} one can preform Signature
#' Overrepresentation Analysis on lists of genes of interest.
#'
#' @name nciTable
#' @docType data
#' @source
#' <https://github.com/NCIP/pathway-interaction-database/tree/master/download>
#' @keywords datasets
#' @examples
#'
#' data(nciTable)
#' nciH <- makeGPS(pathwayTable = load_data("nciTable"))
#' data(idmap)
#' ils <- grep("^IL", idmap[, "Symbol"], value = TRUE)
#' ilnci <- sigora(
#'   queryList = ils, GPSrepo = nciH, level = 3
#' )
#'
NULL


#' Pathway GPS data, extracted from the Reactome repository (Human).
#'
#' Reactome human pathway GPS data, extracted by \code{makeGPS}, default
#' settings. This data can be used by \code{sigora} to preform signature
#' overrepresenation.
#'
#'
#' @name reaH
#' @docType data
#' @references Matthews, L., Gopinath, G., Gillespie, M., Caudy, M., Croft, D.,
#' et al. 2009. \dQuote{Reactome knowledgebase of human biological pathways and
#' processes.} \emph{Nucleic acids research} \bold{37}(Database issue).
#' @source <http://www.reactome.org/>
#' @keywords datasets
#' @examples
#'
#' data(reaH)
#' ## maybe str(reaH) ;  ...
#'
NULL


#' Pathway GPS data, extracted from Reactome repository (Mouse).
#'
#' Reactome mouse pathway GPS data, extracted by \code{makeGPS}, default
#' settings. This data can be used by \code{sigora} to preform signature
#' overrepresenation.
#'
#'
#' @name reaM
#' @docType data
#' @seealso \code{\link{makeGPS}}, \code{\link{sigora}} , \code{\link{kegM}}
#' @references Matthews, L., Gopinath, G., Gillespie, M., Caudy, M., Croft, D.,
#' et al. 2009. \dQuote{Reactome knowledgebase of human biological pathways and
#' processes.} \emph{Nucleic acids research} \bold{37}(Database issue).
#' @source <http://www.reactome.org/>
#' @keywords datasets
#' @examples
#'
#' data(reaM)
#' str(reaM)
#'
NULL

#' Function to randomly select genes associated with randomly pathways.
#'
#' This function first randomly selects a number (np) of pathways, then
#' randomly selects a number (ng) of genes that are associated with at least
#' one of the selected pathways.  The function can be used to compare Sigora's
#' performance to traditional overrepresentation tests.
#'
#' @export
#' @param GPSrepo A signature repository (created by ..) or one of the
#' precompiled options.
#' @param np How many pathways to select.
#' @param ng Number of genes to be selected.
#' @return \item{selectedPathways}{A vector containing the "np"
#' originally selected pathways.}
#' \item{genes}{A vector containing the "ng" selected
#' genes from selectedPathways.}
#' @seealso \code{\link{sigora-package}}
#' @references Foroushani AB, Brinkman FS and Lynn DJ
#' (2013).\dQuote{Pathway-GPS and SIGORA: identifying relevant
#' pathways based on the over-representation of their gene-pair
#' signatures.}\emph{PeerJ}, \bold{1}
#' @keywords functions
#' @examples
#'
#' data("kegH")
#' ## select 50 genes from 3 human KEGG pathways
#' seed=1234
#' set.seed(seed)
#' a1 <- genesFromRandomPathways(kegH,3,50)
#' ## originally selected pathways:
#' a1[["selectedPathways"]]
#' ## what are the genes
#' a1[["genes"]]
#' ## sigora's results
#' sigoraRes <- sigora(GPSrepo =kegH, queryList = a1[["genes"]],
#'         level = 4)
#' ## compare to traditional methods results:
#' oraRes <- ora(a1[["genes"]],kegH)
#' dim(oraRes)
#' oraRes
#'
genesFromRandomPathways <- function(GPSrepo, np, ng) {
  fr <- GPSrepo$origRepo[[3]]
  p1 <- sample(unique(fr[, 1]), np)
  cat("### randomly selected pathways are: \n")
  cat(paste(as.character(GPSrepo$origRepo[[1]])[p1], "\n"))
  g1 <- sample(unique(fr[fr[, 1] %in% p1, 2]), ng)
  queryList <- as.character(GPSrepo$origRepo[[2]])[g1]
  res <- list()
  res[["genes"]] <- queryList
  res[["selectedPathways"]] <- as.character(GPSrepo$origRepo[[1]])[p1]
  invisible(res)
}

#' load and return data when lazyLoad false insted of using data(datastr)
#' @param datastr name of datasets
#' @param package default sigora
#' @return returns the data
#' @export
#' @examples
#' idmap <- load_data("idmap")
#'
load_data <- function(datastr, package = "sigora") {
  utils::data(list = datastr, package = package)
  return(eval(parse(text = datastr)))
}

.getWeightfunc <- function() {
  weightfunc <- list()
  weightfunc$invhm <- function(a, b) {
    0.5 * ((1 / a) + (1 / b))
  }
  weightfunc$reciprod <- function(a, b) {
    1 / (a * b)
  }
  weightfunc$jac <- function(a, b) {
    1 / (a + b - 1)
  }
  weightfunc$topov <- function(a, b) {
    1 / (apply(as.matrix(cbind(a, b)), FUN = min, MARGIN = 1))
  }
  weightfunc$cosine <- function(a, b) {
    1 / (sqrt(a * b))
  }
  weightfunc$noweights <- function(a, b) {
    rep(1, length(a))
  }
  weightfunc$justPUGs <- function(a, b) {
    rep(0, length(a))
  }
  return(weightfunc)
}

#' Sigora's main function.
#'
#' This function determines which Signatures (GPS) from a collection of GPS
#' data (\code{GPSrepo} argument) for the specified pathway repository are
#' present in the specified list of genes of interest (\code{queryList}
#' argument)). It then uses the distribution function of hypergeometric
#' probabilities to identify the pathways whose GPS are over-represented among
#' the present GPS and saves the results to the file specified in the
#' \code{saveFile} argument.
#'
#' @export
#'
#' @param GPSrepo An object created by \code{makeGPS} or one of the precompiled
#' GPS data collections that are provided with this package (currently for KEGG
#' and Reactome). e.g. \code{reaH} for human Reactome GPS, \code{kegH} for
#' human KEGG GPS, and \code{reaM} and \code{kegM} for corresponding mouse GPS.
#' See the examples section for creating and using your own GPS.
#' @param level In hierarchical repositories (e.g. Reactome) number of levels
#' to consider. Recommended value for KEGG: 2, for Reactome: 4.
#' @param markers Whether to take single genes that are uniquely associated
#' with only one pathway into account (i.e. should pathway unique genes/PUGs be
#' considered GPS?). Recommended value: TRUE (1).
#' @param queryList A user specified list of genes of interest ('query list'),
#' as a vector of ENSEMBL/ ENTREZ IDs or gene symbols (HGNC/MGI).
#' @param saveFile If provided, the results are saved here as a tab delimited
#' File (including , for each pathway, a list of genes ordered by their
#' contribution to the statistical significance of the pathway).
#' @param weighting.method The weighting method or GPS. The default weighting
#' scheme for the GPS is the reciproc of the harmonic mean of the degrees of
#' the two component genes of a GPS. A wide range of alternative weighting
#' schemes are pre-implemented (see below). Additional user defined weighting
#' schemes are also supported. Currently, the following alternatives are
#' pre-implemented:\cr
#' 'noweights','cosine','topov','reciprod','jac','justPUGs'and'invhm'.\cr
#' Additional user defined weighting schemes are also supported (see section
#' examples).\cr 'noweights': assigns a constant of 1 to all GPS.\cr 'cosine':
#' all GPS are weighted by the cosine of the degrees of their consituent
#' genes.\cr 'topov': all GPS are weighted by topological overlap of their
#' consituent genes.\cr 'reciprod': all GPS are weighted by reciproc of product
#' of the number of pathway annotations of their consituent genes.\cr 'jac':all
#' GPS are weighted by the jaccard similarity of the pathway annotations
#' consituent genes.\cr 'justPUGs': Analysis is performed using PUGs only.\cr
#' 'invhm': all GPS are weighted by the reciproc of the harmonic mean of the
#' degrees of their consituent genes (default).\cr
#' @param idmap A dataframe for converting between different gene-identifier
#' types (e.g. ENSEMBL, ENTREZ and HGNC-Symbols of genes). Most users do not
#' need to set this argument, as there is a built-in conversion table.
#' @return \item{ summary_results}{A dataframe listing the analysis results.}
#' \item{detailed_results }{A dataframe describing the detailed evidence
#' (present Gene-Pair Signatures) for each pathway.}
#' @seealso \code{\link{sigora-package}} , \code{\link{makeGPS}}
#' @references Foroushani AB, Brinkman FS and Lynn DJ
#' (2013).\dQuote{Pathway-GPS and SIGORA: identifying relevant
#' pathways based on the over-representation of their gene-pair
#' signatures.}\emph{PeerJ}, \bold{1}
#' @keywords functions
#' @examples
#'
#' ## query list
#' ils <- grep(
#'   "^IL", load_data("idmap")[["Symbol"]], value = TRUE
#' )
#' ## using precompiled GPS repositories:
#' sigRes.ilreact <- sigora(
#'   queryList = ils, GPSrepo = load_data("reaH"), level = 4
#' )
#' \donttest{
#' sigRes.ilkeg <- sigora(
#'   queryList = ils, GPSrepo = load_data("kegH"), level = 2
#' )
#' ## user created GPS repository:
#' nciH <- makeGPS(pathwayTable = load_data("nciTable"))
#' sigRes.ilnci <- sigora(
#'   queryList = ils, GPSrepo = nciH, level = 2
#' )
#' ## user defined weighting schemes:
#' myfunc <- function(a, b) {
#'   1 / log(a + b)
#' }
#' sigora(
#'   queryList = ils, GPSrepo = nciH,
#'   level = 2, weighting.method = myfunc
#' )
#' }
sigora <-
  function(
    GPSrepo,
    level,
    markers = FALSE,
    queryList = NULL,
    saveFile = NULL,
    weighting.method = "invhm",
    idmap = load_data("idmap")
  ) {
    if ("character" %in% class(weighting.method)) {
      WEIGHTMETHODS <- names(.getWeightfunc())
      weighting.method <- pmatch(weighting.method, WEIGHTMETHODS)
      weightfunc <- .getWeightfunc()[[weighting.method]]
    } else if ("function" %in% class(weighting.method)) {
      weightfunc <- weighting.method
    } else {
      stop("invalid parameter weighting.method")
    }

    hh <- NULL
    jj <- grep("^L", names(GPSrepo), value = TRUE)
    weights <- 0
    ## mapping
    if (length(intersect(queryList, GPSrepo$origRepo[[2]])) == 0) {
      t1 <-
        which.max(vapply(
          idmap,
          function(x) {
            length(intersect(x, GPSrepo$origRepo[[2]]))
          },
          FUN.VALUE = integer(1)
        ))
      t2 <-
        which.max(vapply(
          idmap,
          function(x) {
            length(intersect(x, queryList))
          },
          FUN.VALUE = integer(1)
        ))
      queryList <- idmap[which(idmap[, t2] %in% queryList), t1]
      print(paste(
        "Mapped identifiers from",
        colnames(idmap)[t2],
        " to ",
        colnames(idmap)[t1],
        "..."
      ))
    }
    for (ind in seq_len(level)) {
      v1 <- GPSrepo[[paste("L", ind, sep = "")]]
      weights <- weightfunc(
        v1$degs[v1$gs[v1$GPS[, 1]]],
        v1$degs[v1$gs[v1$GPS[, 2]]]
      )
      hh <- rbind(
        hh,
        cbind(
          v1$gs[v1$GPS[, 1]],
          v1$gs[v1$GPS[, 2]],
          v1$ps[v1$GPS[, 3]],
          round(weights * 100) / 100
        )
      )
      rm(v1)
    }
    colnames(hh) <- c("gene1", "gene2", "pathway", "weight")
    if (markers == TRUE) {
      for (ind in seq_len(level)) {
        v1 <- GPSrepo[[paste("L", ind, sep = "")]]
        hh <- rbind(
          hh,
          cbind(v1$gs[v1$PU[, 1]], v1$gs[v1$PUG[, 1]], v1$ps[v1$PUG[, 2]], 1)
        )
        rm(v1)
      }
    }
    if (is.null(queryList)) {
      ##TODO
    }
    hhd <-
      (hh[hh[, 1] %in% queryList & hh[, 2] %in% queryList, , drop = FALSE])
    k1 <-
      (stats::aggregate(as.numeric(hhd[, 4]), by = list(hhd[, 3]), FUN = sum))
    kN <-
      (stats::aggregate(as.numeric(hh[, 4]), by = list(hh[, 3]), FUN = sum))
    sum(kN[, 2])
    sum(k1[, 2])
    ps <- stats::phyper(
      k1[, 2] - 1,
      kN[match(k1[, 1], kN[, 1]), 2],
      sum(kN[, 2]) - kN[match(k1[, 1], kN[, 1]), 2],
      sum(k1[, 2]),
      lower.tail = FALSE
    )
    ps <- signif(ps, digits = 4)
    Bonfer <-
      signif(
        stats::p.adjust(
          ps, n = length(unique(hh[, 3])), method = "bonfer"
        ),
        digits = 4
      )
    sp1 <- GPSrepo$pathwaydescriptions
    summary_results <-
      data.frame(
        k1[, 1],
        sp1[match(k1[, 1], sp1[, 1]), 2],
        ps,
        Bonfer,
        k1[, 2],
        kN[match(k1[, 1], kN[, 1]), 2],
        sum(kN[, 2]),
        sum(k1[, 2])
      )
    detailed_results <- hhd
    rownames(detailed_results) <- NULL
    colnames(summary_results) <-
      c(
        "pathwy.id",
        "description",
        "pvalues",
        "Bonferroni",
        "successes",
        "PathwaySize",
        "N",
        "sample.size"
      )
    summary_results <-
      summary_results[with(summary_results, order(pvalues)), ]
    rownames(summary_results) <- seq_len(nrow(summary_results))
    print(summary_results[which(summary_results$Bonfer < 0.01), ])
    res <- list()
    res[["summary_results"]] <- summary_results
    res[["detailed_results"]] <- detailed_results
    if (!is.null(saveFile)) {
      Genes <- vector(
        mode = "character", length = nrow(summary_results)
      )
      for (i in seq_len(nrow(summary_results))) {
        v11 <- getGenes(res, i)
        if ("Symbol" %in% colnames(v11)) {
          Genes[i] <- paste(v11$Symbol, sep = "", collapse = ";")
        } else {
          Genes[i] <- paste(v11[, 1], sep = "", collapse = ";")
        }
      }
      utils::write.table(
        cbind(summary_results, Genes),
        file = saveFile,
        quote = FALSE,
        row.names = FALSE,
        sep = "\t"
      )
    }
    invisible(res)
  }

#' Highlight the relevant genes for a specific pathway in its pathway diagram
#'
#' This function highlights the genes involved in the present GPS for a pathway
#' of interest in its diagram. Please note that this functionality is only
#' implemented for results of Reactome or KEGG based analyses.
#'
#' @export
#' @param yy A sigora analysis result object (created by \code{sigora}).
#' @param i The rank position of the pathway of interest in summary_results.
#' @return The URL of the pathway diagram, where the relevant genes from your
#' original query list are highlighted.
#' @seealso \code{\link{sigora}}
#' @keywords functions
#' @examples
#'
#' data("kegH")
#' set.seed(seed=12345)
#' a1<-genesFromRandomPathways(kegH,3,50)
#' ## originally selected pathways:\cr
#' a1[["selectedPathways"]]
#' ## what are the genes
#' a1[["genes"]]
#' ## sigora's results with this input:\cr
#' sigoraRes <- sigora(GPSrepo =kegH, queryList = a1[["genes"]],level = 2)
#' ## Diagram for the most significant result,
#' ## genes from our list are highlighted in red:
#' getURL(sigoraRes,1)
#'
getURL <- function(yy, i) {
  url <- ""
  repo <-
    ifelse(
      substr(x = yy$summary_results[i, 1], start = 1, 2) == "R-",
      "rea",
      "keg"
    )

  if (repo == "rea") {
    cat(paste("assuming this is a result from Reactome ...", "\n"))
    url <-
      paste(
        "https://reactome.org/ContentService/exporter/diagram//",
        yy$summary_results[i, 1],
        ".png?flg=",
        paste(getGenes(yy, i)[, 4], sep = "", collapse = ","),
        sep = ""
      )
  }

  if (repo == "keg") {
    cat(paste("assuming this is a result from KEGG ...", "\n"))
    url <- paste(
      "https://www.genome.jp/kegg-bin/show_pathway?",
      tolower(yy$summary_results[i, 1]),
      "+",
      paste(getGenes(yy, i)[, 4], sep = "", collapse = "+"),
      sep = ""
    )
  }
  url
}

#' List genes involved in present GPS for a specific pathway in the
#' summary_results
#'
#' This function lists the genes involved in the present GPS for a pathway of
#' interest, odered by their contribution to the significance of the pathway.
#'
#' @export
#' @param yy A sigora analysis result object (created by \code{sigora}).
#' @param i The rank position of the pathway of interest in summary_results.
#' @param idmap A dataframe for converting between different gene-identifier
#' types (e.g. ENSEMBL, ENTREZ and HGNC-Symbols of genes). Most users do not
#' need to set this argument, as there is a built-in conversion table.
#' @return A table (dataframe) with ids of the relevant genes, ranked by their
#' contribution to the statistical significance of the pathway.
#' @seealso \code{\link{sigora}}
#' @keywords functions
#' @examples
#'
#' data("kegH")
#' set.seed(seed=12345)
#' a1 <- genesFromRandomPathways(kegH,3,50)
#' ## originally selected pathways:\cr
#' a1[["selectedPathways"]]
#' ## what are the genes
#' a1[["genes"]]
#' ## sigora's results with this input:\cr
#' sigoraRes <- sigora(GPSrepo = kegH, queryList = a1[["genes"]],level = 2)
#' ## Genes related to the second most significant result:
#' head(getGenes(sigoraRes,2))
#'
getGenes <- function(yy, i, idmap = load_data("idmap")) {
  yy1 <-
    yy$detailed_results[
      which(yy$detailed_results[, "pathway"] == yy$summary_results[i, 1]),
      ,
      drop = FALSE
    ]
  r1 <- stats::aggregate(
    as.numeric(yy1[, 4]), by = list(yy1[, 1]), FUN = sum
  )
  r2 <- stats::aggregate(
    as.numeric(yy1[, 4]), by = list(yy1[, 2]), FUN = sum
  )
  r3 <- stats::aggregate(
    rbind(r1, r2)[, 2],
    by = list(rbind(r1, r2)[, 1]),
    FUN = sum
  )
  r4 <- as.data.frame(r3[order(-r3[, 2]), ])
  r4[, 2] <- 0.5 * r4[, 2]
  colnames(r4) <- c("gene", "contribution")
  v1 <- vapply(
    idmap,
    function(x) {
      length(intersect(x, r4[, 1]))
    },
    FUN.VALUE = integer(1)
  )
  if (max(v1) > 0) {
    t1 <- which.max(v1)
    r4 <- cbind(r4, idmap[match(r4[, 1], idmap[, t1]), -t1])
  }
  rownames(r4) <- NULL
  r4
}

#' Traditional Overrepresentation Analysis.
#'
#' Traditional Overrepresentation Analysis by hypergeometric test: pathways are
#' treated as collections of individual genes and all genes are treated as
#' equally informative. This function is provided for comparison of the results
#' of traditional methods to Sigora.
#'
#' The primary purpose of \code{makeGPS} is to create a GPS repository. It
#' does, however, retain the original "single gene"-"pathway" associations for
#' the purpose of followup analyses, such as comparison of sigora-results to
#' traditional methods. \code{ora} is an implementation of the traditional
#' (individual gene) Overrepresentation Analysis.
#'
#' @export
#' @param geneList A vector containing the list of genes of interest (e.g.
#' differentially expressed genes). Following Identifier types are supported:
#' Gene Symbols, ENTREZ-IDs or ENSEMBL-IDs.
#' @param GPSrepo A GPS-repository (either one of the provided precomputed GPS
#' repositories) or one created by \code{makeGPS}.
#' @param idmap A dataframe for converting between different gene-identifier
#' types (e.g. ENSEMBL, ENTREZ and HGNC-Symbols of genes). Most users do not
#' need to set this argument, as there is a built-in conversion table.
#' @return A dataframe with individual gene ORA results.
#' @seealso \code{\link{sigora-package}}
#' @keywords functions
#' @examples
#'
#' data(kegM)
#' ## select 50 genes from 3 mouse pathways
#' set.seed(seed=345)
#' a1<-genesFromRandomPathways(kegM,3,50)
#' ## originally selected pathways:
#' a1[["selectedPathways"]]
#' ## compare to traditional methods results:
#' oraRes <- ora(a1[["genes"]],kegM)
#' dim(oraRes)
#' oraRes
#'
ora <- function(geneList, GPSrepo, idmap = load_data("idmap")) {
  fr <- GPSrepo$origRepo[[3]]
  sp1 <- GPSrepo$pathwaydescriptions
  if (length(intersect(geneList, GPSrepo$origRepo[[2]])) == 0) {
    t1 <-
      which.max(vapply(
        idmap,
        function(x) {
          length(intersect(
            x,
            GPSrepo$origRepo[[2]]
          ))
        },
        FUN.VALUE = integer(1)
      ))
    t2 <-
      which.max(vapply(
        idmap,
        function(x) {
          length(intersect(x, geneList))
        },
        FUN.VALUE = integer(1)
      ))
    geneList <- idmap[which(idmap[, t2] %in% geneList), t1]
    print(paste(
      "Mapped identifiers from",
      colnames(idmap)[t2],
      " to ",
      colnames(idmap)[t1],
      "..."
    ))
  }
  g1m <- match(geneList, GPSrepo$origRepo[[2]])
  frO <- fr[fr[, 2] %in% g1m, ]
  npwys <- table(as.character(GPSrepo$origRepo[[1]][(frO[, 1])]))
  nn <-
    cbind(sp1[match(names(npwys), sp1[, 1]), ], as.numeric(as.vector(npwys)))
  PPwys <- table(as.character(GPSrepo$origRepo[[1]][(fr[, 1])]))
  ps <- stats::phyper(
    npwys - 1,
    PPwys[match(names(npwys), names(PPwys))],
    length(GPSrepo$origRepo[[2]]) -
      PPwys[match(names(npwys), names(PPwys))],
    length(intersect(geneList, GPSrepo$origRepo[[2]])),
    lower.tail = FALSE
  )
  ps <- signif(ps, digits = 4)
  res <-
    data.frame(
      nn,
      PPwys[match(names(npwys), names(PPwys))],
      as.numeric(ps),
      as.numeric(stats::p.adjust(ps, method = "bonfer"))
    )[, -4]
  colnames(res) <-
    c(
      "pathwyid", "description", "success",
      "pathwaySize", "pvalues", "Bonfer"
    )
  res <- res[with(res, order(pvalues)), ]
  rownames(res) <- c(seq_len(nrow(res)))
  return(res[which(as.numeric(res[, ncol(res)]) < 0.05), ])
}

#' @details
#' Signature Overrepresentation Analysis
#'
#' This package implements the pathway analysis method SIGORA. For an in depth
#' description of the method, please see our manuscript in PeerJ.  In short: a
#' \emph{GPS} (gene pair signature) is a (weighted) pair of genes that \emph{as
#' a combination} occurs only in a single pathway within a pathway repository.
#' A query list is a vector containing a gene list of interest (e.g. genes that
#' are differentially expressed in a particular condition).  A \emph{present}
#' GPS is a GPS for which both components are in the query list.  SIGORA
#' identifies relevant pathways based on the over-representation analysis of
#' their (present) GPS.
#'
#' For more details see the package vignette.
#'
#' @name sigora-package
#' @aliases sigora-package
#' @docType package
#' @author Amir B.K. Foroushani, Fiona S.L. Brinkman, David J. Lynn
#'
#' Maintainer: Witold Wolski <wew@fgcz.ethz.ch>
#' @seealso \code{\link{sigora}}, \code{\link{makeGPS}}, \code{\link{ora}}
#' @references Foroushani AB, Brinkman FS and Lynn DJ
#' (2013).\dQuote{Pathway-GPS and SIGORA: identifying relevant
#' pathways based on the over-representation of their gene-pair
#' signatures.}\emph{PeerJ}, \bold{1}
#' @keywords internal
"_PACKAGE"

#' Create your own Signature Object.
#'
#' Given a repository of gene-pathway associations either in a tab delimited
#' file with three columns (pathwayID,pathway Description,Gene) or a
#' corresponding dataframe, this function identifies all Gene Pair Signatures
#' (pairs of genes that are as a combination unique to a single pathway) and
#' Pathway Unique Genes (genes that are uniquely associated with a single
#' pathway) and stores them in a format that is usable by \code{sigora}.
#' Please also see the "details" and "note" sections below.
#'
#' The primary purpose of \code{makeGPS} is to convert a user-supplied
#' gene-pathway association table to a repository of weighted Gene Pair
#' Signatures (GPS) that are unique features of pathways. Such GPS can than be
#' used for signature (gene-pair) based analyses using \code{sigora}.
#' Additionally, the resulting object also retains the original "single
#' gene"-"pathway" associations for the purpose of followup analyses, such as
#' comparison of sigora-results to traditional methods. \code{ora} is an
#' implementation of the traditional (individual gene) Overrepresentation
#' Analysis.
#' @export
#' @param pathwayTable A data frame describing gene-pathway associations in
#' following format: pathwayID,pathwayName,Gene. Either pathwayTable or fn
#' should be provided.
#' @param fn Where to find the repository.Either pathwayTable or fn should be
#' provided.
#' @param maxLevels For hierarchical repositories, the number of levels to
#' consider.
#' @param saveFile Where to save the object as an rda file.
#' @param repoName Repository name.
#' @param maxFunperGene A cutoff threshold, genes with more than this number of
#' associated pathways are excluded to speed up the GPS identification process.
#' @param maxGenesperPathway A cutoff threshold, pathways with more than this
#' number of associated genes are excluded to speed up the GPS identification
#' process.
#' @param minGenesperPathway A cutoff threshold, pathways with less than this
#' number of associated genes are excluded to speed up the GPS identification
#' process.
#' @return A GPS repository, to be used by \code{sigora} and \code{ora.}
#' @note This function relies on package \code{slam}, which should be installed
#' from CRAN.  It is fairly memory intensive, and it is recommended to be run
#' on a machine with at least 6GB of RAM. Also, make sure to save and reuse the
#' resulting GPS repository in future analyses!
#' @seealso \code{\link{sigora}}, \code{\link{sigora-package}}
#' @references Foroushani AB, Brinkman FS and Lynn DJ
#' (2013).\dQuote{Pathway-GPS and SIGORA: identifying relevant
#' pathways based on the over-representation of their gene-pair
#' signatures.}\emph{PeerJ}, \bold{1}
#' @keywords functions
#' @examples
#'
#' data(nciTable)
#' data(idmap)
#' ## what the input looks like:
#' head(nciTable)
#' ## create a SigObject. use the saveFile parameter for reuse.
#' \donttest{
#' nciH <- makeGPS(pathwayTable = load_data("nciTable"))
#' ils <- grep("^IL", idmap[, "Symbol"], value = TRUE)
#' ilnci <- sigora(queryList = ils, GPSrepo = nciH, level = 3)
#' }
makeGPS <-
  function(
    pathwayTable = NULL,
    fn = NULL,
    maxLevels = 5,
    saveFile = NULL,
    repoName = "userrepo",
    maxFunperGene = 100,
    maxGenesperPathway = 500,
    minGenesperPathway = 10
  ) {
    if (is.null(pathwayTable)) {
      fG <-
        utils::read.table(fn, header = TRUE, sep = "\t", quote = "@")
    } else {
      fG <- pathwayTable
    }
    colnames(fG) <- c("pwys", "nms", "gns")
    fG <- unique(fG)
    valGenes <-
      names(table(fG$gns))[which(table(fG$gns) < (1 + maxFunperGene))]
    valPathways <-
      names(table(fG$pwys))[which(
        table(fG$pwys) < (1 + maxGenesperPathway) &
          table(fG$pwys) >
            (minGenesperPathway -
               1)
      )]

    fG <- fG[which(fG$gns %in% valGenes & fG$pwys %in% valPathways), ]
    L1 <- NULL
    L2 <- NULL
    L3 <- NULL
    L4 <- NULL
    L5 <- NULL
    t1 <- Sys.time()
    makedictionary <- function(y1) {
      upw <- unique(y1$pwys)
      ugn <- unique(y1$gns)
      dy1 <- cbind(match(y1$pwys, upw), match(y1$gns, ugn))
      colnames(dy1) <- c("pwys", "gns")
      res <- list(upw, ugn, dy1)
      invisible(res)
    }
    makesigs <- function(f1) {
      gs <- as.character(unique(f1$gns))
      ps <- as.character(unique(f1$pwys))
      si <- match(f1$gns, gs)
      sj <- match(f1$pwys, ps)
      sv <- rep(1, nrow(f1))
      s <-
        slam::simple_triplet_matrix(
          i = si,
          j = sj,
          v = sv,
          dimnames = list("rownames" = gs, "colnames" = ps)
        )

      M <- slam::tcrossprod_simple_triplet_matrix(s)

      rownames(M) <- gs
      colnames(M) <- gs
      PU <- which(diag(M) == 1)
      m <- as.matrix(s)
      xx <- which(m[PU, , drop = FALSE] == 1, arr.ind = TRUE)[, 2]
      PUG <- cbind(PU, xx[names(PU)])
      GP <- which(M == 1, arr.ind = TRUE)
      GP <- GP[GP[, 1] < GP[, 2], ]
      S <- vector(length = nrow(GP))
      S1 <- PUG[match(GP[, 1], PUG[, 1]), 2]
      S2 <- PUG[match(GP[, 2], PUG[, 1]), 2]
      S <- ifelse(is.na(S1), S2, S1)
      rm(M)
      gc(TRUE)
      for (h1 in which(is.na(S))) {
        S[h1] <- which(m[GP[h1, 1], ] + m[GP[h1, 2], ] == 2)
      }
      GPS <- cbind(GP, S)
      print(Sys.time() - t1)
      rm(m)
      degs <- table(as.character(f1$gns))
      pwyszs <- table(as.character(f1$pwys))
      rownames(GPS) <- NULL
      rownames(PUG) <- NULL
      invisible(list(
        "GPS" = GPS,
        "PUG" = PUG,
        "gs" = gs,
        "ps" = ps,
        "degs" = degs,
        "pwyszs" = pwyszs
      ))
    } ##end internal function

    L1 <- makesigs(fG)
    fG2 <- fG[-which(fG$pwys %in% (L1$ps[unique(L1$GPS[, "S"])])), ]
    if (nrow(fG2) > 1) {
      L2 <- makesigs(fG2)
      fG3 <- fG2[-which(fG2$pwys %in% (L2$ps[unique(L2$GPS[, "S"])])), ]
      if (nrow(fG3) > 1) {
        L3 <- makesigs(fG3)
        fG4 <-
          fG3[-which(fG3$pwys %in% (L3$ps[unique(L3$GPS[, "S"])])), ]
        if (nrow(fG4) > 1) {
          L4 <- makesigs(fG4)
          fG5 <-
            fG4[-which(fG4$pwys %in% (L4$ps[unique(L4$GPS[, "S"])])), ]
          if (nrow(fG5) > 1) {
            L5 <- makesigs(fG5)
          }
        }
      }
    }
    res <- list()
    res[["origRepo"]] <- makedictionary(fG)
    res[["L1"]] <- L1
    res[["L2"]] <- L2
    res[["L3"]] <- L3
    res[["L4"]] <- L4
    res[["L5"]] <- L5
    res[["repoName"]] <- repoName
    res[["pathwaydescriptions"]] <- unique(fG[, seq_len(2)])
    res[["call"]] <- as.character(match.call())
    x1 <- as.character(repoName)
    if (!is.null(saveFile)) {
      cmd2 <- paste(
        "save(", x1, ", file='", saveFile, "')", sep = ""
      )
      assign(x1, res)
      eval(parse(text = cmd2))
    }
    invisible(res)
  }

---
title: "Signature Overrepresentation Analysis - Sigora"
author: "Witold Wolski"
date: "24/11/2021"
output: html_document
vignette: >
  %\VignetteIndexEntry{Signature Overrepresentation Analysis - Sigora} 
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}

---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

# Signature Overrepresentation Analysis

This package implements the pathway analysis method SIGORA. For an in depth
description of the method, please see our manuscript in PeerJ.  In short: a
_GPS_ (gene pair signature) is a (weighted) pair of genes that _as
a combination_ occurs only in a single pathway within a pathway repository.
A query list is a vector containing a gene list of interest (e.g. genes that
are differentially expressed in a particular condition).  A _present_
GPS is a GPS for which both components are in the query list. SIGORA
identifies relevant pathways based on the over-representation analysis of
their (present) GPS.


@section Getting started:


To load the library:

```{r}
library("sigora")
```

# Motivation:

A thought experiment Imagine you randomly selected 3 KEGG
pathways, and then randomly selected a total of 50 genes from
all genes that that are associated with any of these pathways.
Using traditional methods (hypergeometric test using individual
genes), how many pathways would you estimate to show up as
statistically overrepresented in this "query list" of 50 genes?

Let us do this experiment! Everything related to
human KEGG Pathways can be found in `kegH`. A function to
randomly select $n$ genes from m randomly selected pathways
is `genesFromRandomPathways`. The traditional
Overrepresentation Analysis (which is the basis for many
popular tools) is available through `ora`.
Putting these together:

```{r}
data(kegH)
set.seed(seed = 12345)
a1 <- genesFromRandomPathways(kegH, 3, 50)
## originally selected pathways:
a1[["selectedPathways"]] ## what are the genes
a1[["genes"]]
## Traditional ora identifies many significant pathways!

head(ora(a1[["genes"]], kegH))
## Now let us try sigora with the same input:

sigoraRes <-
  sigora(GPSrepo = kegH,
         queryList = a1[["genes"]],
         level = 4)
## Again, the three originally selected pathways were:
a1[["selectedPathways"]]

```

You might want to rerun the above few lines of code with
different values for `seed` and convince yourself that there
indeed is a need for a new way of pathway analysis.

# Available Pathway-GPS repositories in SIGORA:

The current version of the package comes with precomputed
GPS-repositories for __KEGG__ human and mouse (`kegH` and
`kegM` respectively), as well as for __Reactome__ human and
mouse (`reaH` and `reaM` respectively). The package provides
a function for creating GPS-repositories from user's own
gene-function repository of choice (example __Gene Ontology
Biological Processes__). The following section describes this
process of creating one's own GPS-repositories using the
__PCI-NCI__ pathways from National Cancer Institute as an
example.

# Creating a GPS repository:

You can create your own GPS repositories using the
`makeGPS()` function. There are no particular requirements
on the format of your source repository, except: it should
be provided either a tab delimited file or a dataframe with
three columns in the following order:
- PathwayID, PathwayName, Gene.

```{r}
data(nciTable)
## what does the input look like?
head(nciTable)
## create a SigObject. use saveFile for future reuse.
data(idmap)
nciH <- makeGPS(
  pathwayTable = nciTable, saveFile = NULL
)
ils <- grep("^IL", idmap[, "Symbol"], value = TRUE)
ilnci <- sigora(
  queryList = ils, GPSrepo = nciH, level = 3
)

```

# Analysing your data To preform Signature Overrepresentation:

Analysis, use the function `sigora`.  For traditional
Overrepresentation Analysis, use the function `ora`.

# Exporting:

Exporting the results Simply provide a file name to the
`saveFile` parameter of `sigora`, i.e. (for the above
experiment):

```{r}
sigRes <-
  sigora(kegH,
         queryList = a1$genes,
         level = 2,
         saveFile = NULL)

```

You will notice that the file also contains the list of the
relevant genes from the query list in each pathway. The genes
are listed as human readable gene symbols and sorted by their
contribution to the statistical significance of the pathway.

# Gene identifier mapping Mappings:

between __ENSEMBL__-IDS, __ENTREZ__-IDS and Gene-Symbols
are performed automatically.

You can, for instance, create a __GPS__-repository using
__ENSEMBL__-IDs and perform __Signature Overrepresentation
Analysis__ using this repository on a list of
__ENTREZ__-IDs.

```{r}
data("kegH")
data("idmap")
barplot(
  table(kegH$L1$degs),
  col = "red",
  main = "functions per gene in KEGG human pathways",
  ylab = "frequency",
  xlab = "number of functions per gene"
)
## creating your own GPS repository
nciH <- makeGPS(pathwayTable = load_data("nciTable"))
ils <- grep(
  "^IL", idmap[, "Symbol"], value = TRUE
)
## signature overrepresentation analysis:
sigRes.ilnci <- sigora(
  queryList = ils, GPSrepo = nciH, level = 3
)

```


# Session

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aa_package.R
\docType{data}
\name{kegH}
\alias{kegH}
\title{Pathway GPS data, extracted from KEGG repository (Human).}
\source{
<http://www.genome.jp/kegg/pathway.html>
}
\description{
KEGG human pathway GPS data, extracted by \code{makeGPS}, default settings.
This data can be used by \code{sigora} to preform signature
overrepresenation.
}
\examples{

data(kegH)
str(kegH)

}
\references{
Kanehisa, M., Goto, S., Sato, Y., Furumichi, M., & Tanabe, M.
2012. \dQuote{KEGG for integration and interpretation of large-scale
molecular data sets.} \emph{Nucleic Acids Research} \bold{40}(D1).
}
\seealso{
\code{\link{makeGPS}}, \code{\link{sigora}} , \code{\link{reaH}}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getGenes.R
\name{getGenes}
\alias{getGenes}
\title{List genes involved in present GPS for a specific pathway in the
summary_results}
\usage{
getGenes(yy, i, idmap = load_data("idmap"))
}
\arguments{
\item{yy}{A sigora analysis result object (created by \code{sigora}).}

\item{i}{The rank position of the pathway of interest in summary_results.}

\item{idmap}{A dataframe for converting between different gene-identifier
types (e.g. ENSEMBL, ENTREZ and HGNC-Symbols of genes). Most users do not
need to set this argument, as there is a built-in conversion table.}
}
\value{
A table (dataframe) with ids of the relevant genes, ranked by their
contribution to the statistical significance of the pathway.
}
\description{
This function lists the genes involved in the present GPS for a pathway of
interest, odered by their contribution to the significance of the pathway.
}
\examples{

data("kegH")
set.seed(seed=12345)
a1 <- genesFromRandomPathways(kegH,3,50)
## originally selected pathways:\cr
a1[["selectedPathways"]]
## what are the genes
a1[["genes"]]
## sigora's results with this input:\cr
sigoraRes <- sigora(GPSrepo = kegH, queryList = a1[["genes"]],level = 2)
## Genes related to the second most significant result:
head(getGenes(sigoraRes,2))

}
\seealso{
\code{\link{sigora}}
}
\keyword{functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ora.R
\name{ora}
\alias{ora}
\title{Traditional Overrepresentation Analysis.}
\usage{
ora(geneList, GPSrepo, idmap = load_data("idmap"))
}
\arguments{
\item{geneList}{A vector containing the list of genes of interest (e.g.
differentially expressed genes). Following Identifier types are supported:
Gene Symbols, ENTREZ-IDs or ENSEMBL-IDs.}

\item{GPSrepo}{A GPS-repository (either one of the provided precomputed GPS
repositories) or one created by \code{makeGPS}.}

\item{idmap}{A dataframe for converting between different gene-identifier
types (e.g. ENSEMBL, ENTREZ and HGNC-Symbols of genes). Most users do not
need to set this argument, as there is a built-in conversion table.}
}
\value{
A dataframe with individual gene ORA results.
}
\description{
Traditional Overrepresentation Analysis by hypergeometric test: pathways are
treated as collections of individual genes and all genes are treated as
equally informative. This function is provided for comparison of the results
of traditional methods to Sigora.
}
\details{
The primary purpose of \code{makeGPS} is to create a GPS repository. It
does, however, retain the original "single gene"-"pathway" associations for
the purpose of followup analyses, such as comparison of sigora-results to
traditional methods. \code{ora} is an implementation of the traditional
(individual gene) Overrepresentation Analysis.
}
\examples{

data(kegM)
## select 50 genes from 3 mouse pathways
set.seed(seed=345)
a1<-genesFromRandomPathways(kegM,3,50)
## originally selected pathways:
a1[["selectedPathways"]]
## compare to traditional methods results:
oraRes <- ora(a1[["genes"]],kegM)
dim(oraRes)
oraRes

}
\seealso{
\code{\link{sigora-package}}
}
\keyword{functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sigora-package.R
\docType{package}
\name{sigora-package}
\alias{sigora-package}
\title{sigora: Signature Overrepresentation Analysis}
\description{
Pathway Analysis is statistically linking observations on the molecular level to biological processes or pathways on the systems(i.e., organism, organ, tissue, cell) level. Traditionally, pathway analysis methods regard pathways as collections of single genes and treat all genes in a pathway as equally informative. However, this can lead to identifying spurious pathways as statistically significant since components are often shared amongst pathways. SIGORA seeks to avoid this pitfall by focusing on genes or gene pairs that are (as a combination) specific to a single pathway. In relying on such pathway gene-pair signatures (Pathway-GPS), SIGORA inherently uses the status of other genes in the experimental context to identify the most relevant pathways. The current version allows for pathway analysis of human and mouse datasets. In addition, it contains pre-computed Pathway-GPS data for pathways in the KEGG and Reactome pathway repositories and mechanisms for extracting GPS for user-supplied repositories.
}
\details{
Signature Overrepresentation Analysis

This package implements the pathway analysis method SIGORA. For an in depth
description of the method, please see our manuscript in PeerJ.  In short: a
\emph{GPS} (gene pair signature) is a (weighted) pair of genes that \emph{as
a combination} occurs only in a single pathway within a pathway repository.
A query list is a vector containing a gene list of interest (e.g. genes that
are differentially expressed in a particular condition).  A \emph{present}
GPS is a GPS for which both components are in the query list.  SIGORA
identifies relevant pathways based on the over-representation analysis of
their (present) GPS.

For more details see the package vignette.
}
\references{
Foroushani AB, Brinkman FS and Lynn DJ
(2013).\dQuote{Pathway-GPS and SIGORA: identifying relevant
pathways based on the over-representation of their gene-pair
signatures.}\emph{PeerJ}, \bold{1}
}
\seealso{
\code{\link{sigora}}, \code{\link{makeGPS}}, \code{\link{ora}}
}
\author{
Amir B.K. Foroushani, Fiona S.L. Brinkman, David J. Lynn

Maintainer: Witold Wolski <wew@fgcz.ethz.ch>
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aa_package.R
\docType{data}
\name{idmap}
\alias{idmap}
\title{Identifier mappings for protein coding genes.}
\source{
www.ensembl.org/biomart/martview
}
\description{
A mapping table for ENSEMBL, ENTREZ and gene names(HGNC/MGI symbols) of
Human and mouse protein coding gene.
}
\examples{

data(idmap)
head(idmap)

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genesFromRandomPathways.R
\name{genesFromRandomPathways}
\alias{genesFromRandomPathways}
\title{Function to randomly select genes associated with randomly pathways.}
\usage{
genesFromRandomPathways(GPSrepo, np, ng)
}
\arguments{
\item{GPSrepo}{A signature repository (created by ..) or one of the
precompiled options.}

\item{np}{How many pathways to select.}

\item{ng}{Number of genes to be selected.}
}
\value{
\item{selectedPathways}{A vector containing the "np"
originally selected pathways.}
\item{genes}{A vector containing the "ng" selected
genes from selectedPathways.}
}
\description{
This function first randomly selects a number (np) of pathways, then
randomly selects a number (ng) of genes that are associated with at least
one of the selected pathways.  The function can be used to compare Sigora's
performance to traditional overrepresentation tests.
}
\examples{

data("kegH")
## select 50 genes from 3 human KEGG pathways
seed=1234
set.seed(seed)
a1 <- genesFromRandomPathways(kegH,3,50)
## originally selected pathways:
a1[["selectedPathways"]]
## what are the genes
a1[["genes"]]
## sigora's results
sigoraRes <- sigora(GPSrepo =kegH, queryList = a1[["genes"]],
        level = 4)
## compare to traditional methods results:
oraRes <- ora(a1[["genes"]],kegH)
dim(oraRes)
oraRes

}
\references{
Foroushani AB, Brinkman FS and Lynn DJ
(2013).\dQuote{Pathway-GPS and SIGORA: identifying relevant
pathways based on the over-representation of their gene-pair
signatures.}\emph{PeerJ}, \bold{1}
}
\seealso{
\code{\link{sigora-package}}
}
\keyword{functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sigora.R
\name{sigora}
\alias{sigora}
\title{Sigora's main function.}
\usage{
sigora(
  GPSrepo,
  level,
  markers = FALSE,
  queryList = NULL,
  saveFile = NULL,
  weighting.method = "invhm",
  idmap = load_data("idmap")
)
}
\arguments{
\item{GPSrepo}{An object created by \code{makeGPS} or one of the precompiled
GPS data collections that are provided with this package (currently for KEGG
and Reactome). e.g. \code{reaH} for human Reactome GPS, \code{kegH} for
human KEGG GPS, and \code{reaM} and \code{kegM} for corresponding mouse GPS.
See the examples section for creating and using your own GPS.}

\item{level}{In hierarchical repositories (e.g. Reactome) number of levels
to consider. Recommended value for KEGG: 2, for Reactome: 4.}

\item{markers}{Whether to take single genes that are uniquely associated
with only one pathway into account (i.e. should pathway unique genes/PUGs be
considered GPS?). Recommended value: TRUE (1).}

\item{queryList}{A user specified list of genes of interest ('query list'),
as a vector of ENSEMBL/ ENTREZ IDs or gene symbols (HGNC/MGI).}

\item{saveFile}{If provided, the results are saved here as a tab delimited
File (including , for each pathway, a list of genes ordered by their
contribution to the statistical significance of the pathway).}

\item{weighting.method}{The weighting method or GPS. The default weighting
scheme for the GPS is the reciproc of the harmonic mean of the degrees of
the two component genes of a GPS. A wide range of alternative weighting
schemes are pre-implemented (see below). Additional user defined weighting
schemes are also supported. Currently, the following alternatives are
pre-implemented:\cr
'noweights','cosine','topov','reciprod','jac','justPUGs'and'invhm'.\cr
Additional user defined weighting schemes are also supported (see section
examples).\cr 'noweights': assigns a constant of 1 to all GPS.\cr 'cosine':
all GPS are weighted by the cosine of the degrees of their consituent
genes.\cr 'topov': all GPS are weighted by topological overlap of their
consituent genes.\cr 'reciprod': all GPS are weighted by reciproc of product
of the number of pathway annotations of their consituent genes.\cr 'jac':all
GPS are weighted by the jaccard similarity of the pathway annotations
consituent genes.\cr 'justPUGs': Analysis is performed using PUGs only.\cr
'invhm': all GPS are weighted by the reciproc of the harmonic mean of the
degrees of their consituent genes (default).\cr}

\item{idmap}{A dataframe for converting between different gene-identifier
types (e.g. ENSEMBL, ENTREZ and HGNC-Symbols of genes). Most users do not
need to set this argument, as there is a built-in conversion table.}
}
\value{
\item{ summary_results}{A dataframe listing the analysis results.}
\item{detailed_results }{A dataframe describing the detailed evidence
(present Gene-Pair Signatures) for each pathway.}
}
\description{
This function determines which Signatures (GPS) from a collection of GPS
data (\code{GPSrepo} argument) for the specified pathway repository are
present in the specified list of genes of interest (\code{queryList}
argument)). It then uses the distribution function of hypergeometric
probabilities to identify the pathways whose GPS are over-represented among
the present GPS and saves the results to the file specified in the
\code{saveFile} argument.
}
\examples{

## query list
ils <- grep(
  "^IL", load_data("idmap")[["Symbol"]], value = TRUE
)
## using precompiled GPS repositories:
sigRes.ilreact <- sigora(
  queryList = ils, GPSrepo = load_data("reaH"), level = 4
)
\donttest{
sigRes.ilkeg <- sigora(
  queryList = ils, GPSrepo = load_data("kegH"), level = 2
)
## user created GPS repository:
nciH <- makeGPS(pathwayTable = load_data("nciTable"))
sigRes.ilnci <- sigora(
  queryList = ils, GPSrepo = nciH, level = 2
)
## user defined weighting schemes:
myfunc <- function(a, b) {
  1 / log(a + b)
}
sigora(
  queryList = ils, GPSrepo = nciH,
  level = 2, weighting.method = myfunc
)
}
}
\references{
Foroushani AB, Brinkman FS and Lynn DJ
(2013).\dQuote{Pathway-GPS and SIGORA: identifying relevant
pathways based on the over-representation of their gene-pair
signatures.}\emph{PeerJ}, \bold{1}
}
\seealso{
\code{\link{sigora-package}} , \code{\link{makeGPS}}
}
\keyword{functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/load_data.R
\name{load_data}
\alias{load_data}
\title{load and return data when lazyLoad false insted of using data(datastr)}
\usage{
load_data(datastr, package = "sigora")
}
\arguments{
\item{datastr}{name of datasets}

\item{package}{default sigora}
}
\value{
returns the data
}
\description{
load and return data when lazyLoad false insted of using data(datastr)
}
\examples{
idmap <- load_data("idmap")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeGPS.R
\name{makeGPS}
\alias{makeGPS}
\title{Create your own Signature Object.}
\usage{
makeGPS(
  pathwayTable = NULL,
  fn = NULL,
  maxLevels = 5,
  saveFile = NULL,
  repoName = "userrepo",
  maxFunperGene = 100,
  maxGenesperPathway = 500,
  minGenesperPathway = 10
)
}
\arguments{
\item{pathwayTable}{A data frame describing gene-pathway associations in
following format: pathwayID,pathwayName,Gene. Either pathwayTable or fn
should be provided.}

\item{fn}{Where to find the repository.Either pathwayTable or fn should be
provided.}

\item{maxLevels}{For hierarchical repositories, the number of levels to
consider.}

\item{saveFile}{Where to save the object as an rda file.}

\item{repoName}{Repository name.}

\item{maxFunperGene}{A cutoff threshold, genes with more than this number of
associated pathways are excluded to speed up the GPS identification process.}

\item{maxGenesperPathway}{A cutoff threshold, pathways with more than this
number of associated genes are excluded to speed up the GPS identification
process.}

\item{minGenesperPathway}{A cutoff threshold, pathways with less than this
number of associated genes are excluded to speed up the GPS identification
process.}
}
\value{
A GPS repository, to be used by \code{sigora} and \code{ora.}
}
\description{
Given a repository of gene-pathway associations either in a tab delimited
file with three columns (pathwayID,pathway Description,Gene) or a
corresponding dataframe, this function identifies all Gene Pair Signatures
(pairs of genes that are as a combination unique to a single pathway) and
Pathway Unique Genes (genes that are uniquely associated with a single
pathway) and stores them in a format that is usable by \code{sigora}.
Please also see the "details" and "note" sections below.
}
\details{
The primary purpose of \code{makeGPS} is to convert a user-supplied
gene-pathway association table to a repository of weighted Gene Pair
Signatures (GPS) that are unique features of pathways. Such GPS can than be
used for signature (gene-pair) based analyses using \code{sigora}.
Additionally, the resulting object also retains the original "single
gene"-"pathway" associations for the purpose of followup analyses, such as
comparison of sigora-results to traditional methods. \code{ora} is an
implementation of the traditional (individual gene) Overrepresentation
Analysis.
}
\note{
This function relies on package \code{slam}, which should be installed
from CRAN.  It is fairly memory intensive, and it is recommended to be run
on a machine with at least 6GB of RAM. Also, make sure to save and reuse the
resulting GPS repository in future analyses!
}
\examples{

data(nciTable)
data(idmap)
## what the input looks like:
head(nciTable)
## create a SigObject. use the saveFile parameter for reuse.
\donttest{
nciH <- makeGPS(pathwayTable = load_data("nciTable"))
ils <- grep("^IL", idmap[, "Symbol"], value = TRUE)
ilnci <- sigora(queryList = ils, GPSrepo = nciH, level = 3)
}
}
\references{
Foroushani AB, Brinkman FS and Lynn DJ
(2013).\dQuote{Pathway-GPS and SIGORA: identifying relevant
pathways based on the over-representation of their gene-pair
signatures.}\emph{PeerJ}, \bold{1}
}
\seealso{
\code{\link{sigora}}, \code{\link{sigora-package}}
}
\keyword{functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aa_package.R
\docType{data}
\name{kegM}
\alias{kegM}
\title{Pathway GPS data, extracted from KEGG repository (Mouse).}
\source{
<http://www.genome.jp/kegg/pathway.html>
}
\description{
KEGG mouse pathway GPS data, extracted by \code{makeGPS}, default settings.
This data can be used by \code{sigora} to preform signature
overrepresenation.
}
\examples{

data(kegM)
## maybe str(kegM) ; plot(kegM) ...

}
\references{
Kanehisa, M., Goto, S., Sato, Y., Furumichi, M., & Tanabe, M.
2012. \dQuote{KEGG for integration and interpretation of large-scale
molecular data sets.} \emph{Nucleic Acids Research} \bold{40}(D1).
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getURL.R
\name{getURL}
\alias{getURL}
\title{Highlight the relevant genes for a specific pathway in its pathway diagram}
\usage{
getURL(yy, i)
}
\arguments{
\item{yy}{A sigora analysis result object (created by \code{sigora}).}

\item{i}{The rank position of the pathway of interest in summary_results.}
}
\value{
The URL of the pathway diagram, where the relevant genes from your
original query list are highlighted.
}
\description{
This function highlights the genes involved in the present GPS for a pathway
of interest in its diagram. Please note that this functionality is only
implemented for results of Reactome or KEGG based analyses.
}
\examples{

data("kegH")
set.seed(seed=12345)
a1<-genesFromRandomPathways(kegH,3,50)
## originally selected pathways:\cr
a1[["selectedPathways"]]
## what are the genes
a1[["genes"]]
## sigora's results with this input:\cr
sigoraRes <- sigora(GPSrepo =kegH, queryList = a1[["genes"]],level = 2)
## Diagram for the most significant result,
## genes from our list are highlighted in red:
getURL(sigoraRes,1)

}
\seealso{
\code{\link{sigora}}
}
\keyword{functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aa_package.R
\docType{data}
\name{reaH}
\alias{reaH}
\title{Pathway GPS data, extracted from the Reactome repository (Human).}
\source{
<http://www.reactome.org/>
}
\description{
Reactome human pathway GPS data, extracted by \code{makeGPS}, default
settings. This data can be used by \code{sigora} to preform signature
overrepresenation.
}
\examples{

data(reaH)
## maybe str(reaH) ;  ...

}
\references{
Matthews, L., Gopinath, G., Gillespie, M., Caudy, M., Croft, D.,
et al. 2009. \dQuote{Reactome knowledgebase of human biological pathways and
processes.} \emph{Nucleic acids research} \bold{37}(Database issue).
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aa_package.R
\docType{data}
\name{nciTable}
\alias{nciTable}
\title{NCI human gene-pathway associations.}
\source{
<https://github.com/NCIP/pathway-interaction-database/tree/master/download>
}
\description{
PID-NCI human pathway repository, as a data frame with three columns
corresponding to : pathwayId , pathwayName, gene. This is an example of the
expected format for the input data to \code{makeGPS}.
}
\details{
This dataset is provided to illustrate how to create your own GPS
repositories.\code{nciTable} is a dataframe with threecolumns corresponding
to pathwayId, pathwayName and gene.  Each row describes the association
between an individual gene and a PID-NCI pathway.  As you see in the
\code{examples}, section, one can convert this dataframe to a \code{GPS
repository} using \code{makeGPS}, and save the results for future reuse.
Using the thus created \code{GPS repository} one can preform Signature
Overrepresentation Analysis on lists of genes of interest.
}
\examples{

data(nciTable)
nciH <- makeGPS(pathwayTable = load_data("nciTable"))
data(idmap)
ils <- grep("^IL", idmap[, "Symbol"], value = TRUE)
ilnci <- sigora(
  queryList = ils, GPSrepo = nciH, level = 3
)

}
\keyword{datasets}
